#!/usr/bin/perl
# This Script may not be given away
# without the accompanying online.txt file.
# It is totally useless without the other RalfChat scripts.
# This Script is Freeware.
# Created and Copyright by Ralf Gueldemeister <ralfg@bigfoot.com>
# on 25.12.98
# Rearranged by Marcel Solca <marcel@weltendinge.com>
# on 2.2.00
########################################################################
# This script displays users and number of users online (in chatroom)
########################################################################

require config;

################################################
# HTML Part
################################################


#STILLALIVE.HTML - the users online frame
sub stillalive_html_header {
	print <<"[END]";
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="10; URL=http://cgi.anthroposophy.net/communication/chat/online.cgi?action=stillalive">
<META HTTP-EQUIV="expires" CONTENT="0">
<META HTTP-EQUIV="pragma" CONTENT="no-cache">
</HEAD>
$html_bodytag2
<font face=Verdana,Arial,Helvetica size=2>
[END]
}
sub stillalive_html_footer {
	print <<"[END]";
</BODY></HTML>
[END]
&number_of_users_online

}

########################
# END HTML PART.
#######################


################################################
# Main Part - DON'T CHANGE ANYTHING HERE!
###############################################

&action;	# Fuehrt je nach action variable gegebene sub aus
			# action im FORM definieren!

exit;

sub action {
	&stillalive;
}


sub stillalive { # stillalive/who prozedur
	if (-e "$data_dir/$data_stillalive_file") { # SAfile oeffnen/erstellen
	} else {
		&create_file("$data_dir/$data_stillalive_file");        
	}

	open (SAFILE, "<$data_dir/$data_stillalive_file") || &error("opening safile failed");
	flock(SAFILE,2); 
	my $safile = <SAFILE>; # Daten aus safile an $safile uebergeben
	close SAFILE;

	local @sa = split (/;;/, $safile);

	&repair_safile if ($#sa % 2 == 0); # wenn safile fehlerhaft -> repair

	my $ownsaexists = 0;
	my $i = 0;
	for ($i = 0; $i <= $#sa; $i += 2) { # eigenen Eintrag erneuern
		if ($sa[$i] eq $query{'name'}) {
			$sa[$i+1] = time;
			$ownsaexists=1;
		}
	}

	$safile = join(';;', @sa);

	open (SAFILE, ">$data_dir/$data_stillalive_file") || &error("opening safile failed");
	flock(SAFILE,2);

	print SAFILE $safile;

	close SAFILE;

	my $nrusers = ($#sa+1) / 2;
	my $s = $nrusers > 1 ? "s" : "";
	if ($nrusers < 1) {$s = "s"};
	if ($nrusers < 1) {$nrusers = "no"};
	
		&header;
		&stillalive_html_header;

		print "<div align=left><table width=100% cellpadding=0 cellspacing=0 border=0><tr><td width=10><td align=left valign=top><table border=1 width=100% cellpadding=3 cellspacing=0 bgcolor=#000000 bordercolor=#FFAE17 bordercolorlight=#FFD382 bordercolordark=#C48000><tr><td><font face=Verdana,Arial,Helvetica size=1 color=#FFBC40><b><font color=#FF0000>$nrusers</font> user$s online</b></font></td><tr></table><p>";
		for ($i=0; $i<=$#sa; $i+=2) {
			print "<table border=1 width=100% cellpadding=3 cellspacing=0 bgcolor=#000000 bordercolor=#FFAE17 bordercolorlight=#FFD382 bordercolordark=#C48000><tr><td><font face=Verdana,Arial,Helvetica size=1 color=#FFBC40><b>$sa[$i]</b></td></tr>";
		}
		print "</table></td></tr></table></div>";
		&stillalive_html_footer;
}


sub number_of_users_online {
    open (SAFILE, "<$data_dir/$data_stillalive_file");
    flock(SAFILE,2); 
    my $safile = <SAFILE>; # Daten aus safile an $safile uebergeben
#    flock(SAFILE,8);
    close SAFILE;

    local @sa = split (/;;/, $safile);

	&repair_safile if ($#sa % 2 == 0); # wenn safile fehlerhaft -> repair

    # Eintraege nach ueberfaelligen (aelter als 5s) durchsuchen und diese entfernen    
    for (my $i=1; $i<=$#sa; $i+=2) { 
        if ($sa[$i] < (time - 5)) { # ist zeitstempel schon aelter als 5s?
            $sa[$i] = "//2delete";
            $sa[$i-1] = "//2delete";  # zu loeschende eintraege mit //2delete ersetzten
        }  
    }
    # alle Felder mit //2delete entfernen
    my $templsa = $#sa; # Laenge von @sa wird in templsa gespeichert;
    for (my $i=0; $i<=$templsa; $i++) {
        my $temp = shift(@sa);
        if ($temp ne "//2delete") {
            push(@sa,$temp);
        }
    }

    $safile = join(';;', @sa);
    
    open (SAFILE, ">$data_dir/$data_stillalive_file");
    flock(SAFILE,2);

    print SAFILE $safile;

#    flock(SAFILE,8);
    close SAFILE;
    
    my $nrusers = ($#sa+1) / 2;
    return $nrusers;
}


########################
# END Main Part
########################
